# coding: utf-8

"""
    Agilicus API

    Agilicus API endpoints  # noqa: E501

    The version of the OpenAPI document: 2021.03.26
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class AllowRuleCompiled(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'paths': 'list[str]',
        'methods': 'list[str]',
        'any_auth_user': 'bool'
    }

    attribute_map = {
        'paths': 'paths',
        'methods': 'methods',
        'any_auth_user': 'any_auth_user'
    }

    def __init__(self, paths=None, methods=None, any_auth_user=None, local_vars_configuration=None):  # noqa: E501
        """AllowRuleCompiled - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._paths = None
        self._methods = None
        self._any_auth_user = None
        self.discriminator = None

        if paths is not None:
            self.paths = paths
        if methods is not None:
            self.methods = methods
        if any_auth_user is not None:
            self.any_auth_user = any_auth_user

    @property
    def paths(self):
        """Gets the paths of this AllowRuleCompiled.  # noqa: E501

        A list of HTTP paths   # noqa: E501

        :return: The paths of this AllowRuleCompiled.  # noqa: E501
        :rtype: list[str]
        """
        return self._paths

    @paths.setter
    def paths(self, paths):
        """Sets the paths of this AllowRuleCompiled.

        A list of HTTP paths   # noqa: E501

        :param paths: The paths of this AllowRuleCompiled.  # noqa: E501
        :type: list[str]
        """

        self._paths = paths

    @property
    def methods(self):
        """Gets the methods of this AllowRuleCompiled.  # noqa: E501

        The HTTP methods to allow. If any of the listed methods are matched, then this portion of the rule matches.   # noqa: E501

        :return: The methods of this AllowRuleCompiled.  # noqa: E501
        :rtype: list[str]
        """
        return self._methods

    @methods.setter
    def methods(self, methods):
        """Sets the methods of this AllowRuleCompiled.

        The HTTP methods to allow. If any of the listed methods are matched, then this portion of the rule matches.   # noqa: E501

        :param methods: The methods of this AllowRuleCompiled.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["get", "put", "post", "delete", "head", "options", "connect", "trace", "patch", "copy", "lock", "mkcol", "move", "propfind", "proppatch", "unlock", "all"]  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                not set(methods).issubset(set(allowed_values))):  # noqa: E501
            raise ValueError(
                "Invalid values for `methods` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(methods) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._methods = methods

    @property
    def any_auth_user(self):
        """Gets the any_auth_user of this AllowRuleCompiled.  # noqa: E501

        If true, the authorization scope allows any authenticated user the methods/paths outlined in this rule. If false, the user does not require authentication.   # noqa: E501

        :return: The any_auth_user of this AllowRuleCompiled.  # noqa: E501
        :rtype: bool
        """
        return self._any_auth_user

    @any_auth_user.setter
    def any_auth_user(self, any_auth_user):
        """Sets the any_auth_user of this AllowRuleCompiled.

        If true, the authorization scope allows any authenticated user the methods/paths outlined in this rule. If false, the user does not require authentication.   # noqa: E501

        :param any_auth_user: The any_auth_user of this AllowRuleCompiled.  # noqa: E501
        :type: bool
        """

        self._any_auth_user = any_auth_user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AllowRuleCompiled):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AllowRuleCompiled):
            return True

        return self.to_dict() != other.to_dict()
